package com.iformall.domain.po;

import com.baomidou.mybatisplus.annotation.TableName;
import com.google.gson.JsonObject;
import com.iformall.utils.Constant;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import java.util.Date;

@TableName(value = "tt_merchant_poi")
@Data
@ToString(callSuper = true)
@EqualsAndHashCode(callSuper = true)
public class TtMerchantPoi extends BaseEntity {

    protected Long id;//merchant_id

	@io.swagger.annotations.ApiModelProperty(value="租户ID",name="tenantId")
	private String tenantId;

	@io.swagger.annotations.ApiModelProperty(value="父租户ID",name="parentTenantId")
	protected String parentTenantId;

	@io.swagger.annotations.ApiModelProperty(value=" merchant_id",name="supplierExtId")
	private String supplierExtId;

	@io.swagger.annotations.ApiModelProperty(value="商户名",name="merchantName")
	private String merchantName;

	@io.swagger.annotations.ApiModelProperty(value="商户省",name="merchantProvince")
	private String merchantProvince;

	@io.swagger.annotations.ApiModelProperty(value="商户市",name="merchantCity")
	private String merchantCity;

	@io.swagger.annotations.ApiModelProperty(value="商户地址",name="merchantAddr")
	private String merchantAddr;

	@io.swagger.annotations.ApiModelProperty(value="经度",name="longitude")
	private Float longitude;

	@io.swagger.annotations.ApiModelProperty(value="纬度",name="latitude")
	private Float latitude;

	@io.swagger.annotations.ApiModelProperty(value="高德POI ID",name="amapId")
	private String amapId;

	@io.swagger.annotations.ApiModelProperty(value="其他信息",name="extra")
	private String extra;

	@io.swagger.annotations.ApiModelProperty(value="高德POI ID/抖音POIID",name="poiId")
	private String poiId;

	@io.swagger.annotations.ApiModelProperty(value="poi名称 ",name="poiName")
	private String poiName;

	@io.swagger.annotations.ApiModelProperty(value="省",name="province")
	private String province;

	@io.swagger.annotations.ApiModelProperty(value="市",name="city")
	private String city;

	@io.swagger.annotations.ApiModelProperty(value="地址",name="address")
	private String address;

	@io.swagger.annotations.ApiModelProperty(value="抖音平台任务ID",name="taskId")
	private String taskId;

	@io.swagger.annotations.ApiModelProperty(value="EnumSupplierMathStatus 匹配状态，0-等待匹配，1-正在匹配，2-匹配成功，3-匹配失败",name="matchStatus")
	private Integer matchStatus;

	@io.swagger.annotations.ApiModelProperty(value="匹配状态描述",name="mismatchStatusDesc")
	private String mismatchStatusDesc;

	@io.swagger.annotations.ApiModelProperty(value="创建时间",name="createDate")
	private Date createDate;
	@io.swagger.annotations.ApiModelProperty(value="更新时间",name="updateDate")
	private Date updateDate;

	@io.swagger.annotations.ApiModelProperty(value="抖音平台商户ID",name="supplierId")
	private String supplierId;

	@io.swagger.annotations.ApiModelProperty(value="EnumSupplierSyncStatus 同步状态, 0 - 未处理; 1 - 通过; 2 - 未通过",name="syncStatus")
	private Integer syncStatus;

	@io.swagger.annotations.ApiModelProperty(value="EnumSupplierSyncStatus 最近一次同步状态, 0 - 未处理; 1 - 通过; 2 - 未通过",name="lastSyncStatus")
	private Integer lastSyncStatus;

	@io.swagger.annotations.ApiModelProperty(value="同步失败原因，抖音风控政策问题，该字段无法提供太多信息，目前审核不通过联系抖音运营做进一步处理",name="failReason")
	private String failReason;


	@io.swagger.annotations.ApiModelProperty(value="商铺营业执照路径",name="bizLicencePath")
	private String bizLicencePath;
	@io.swagger.annotations.ApiModelProperty(value="营业执照审核详细",name="bizLicenceStatus")
	private String bizLicenceStatus;
	@io.swagger.annotations.ApiModelProperty(value="商家授权函（或与小程序的合作协议）路径",name="contractPath")
	private String contractPath;
	@io.swagger.annotations.ApiModelProperty(value="商家授权函审核详细",name="contractStatus")
	private String contractStatus;
	@io.swagger.annotations.ApiModelProperty(value="商铺行业资质材料信息",name="qualMaterial")
	private String qualMaterial;
	@io.swagger.annotations.ApiModelProperty(value="商铺行业资质材料信息审核详细",name="qualMaterialStatus")
	private String qualMaterialStatus;
	@io.swagger.annotations.ApiModelProperty(value="其他补充资质",name="additionalQual")
	private String additionalQual;
	@io.swagger.annotations.ApiModelProperty(value="其他补充资质审核详细",name="additionalQualStatus")
	private String additionalQualStatus;
	@io.swagger.annotations.ApiModelProperty(value="所有资质的最早过期时间",name="expireTime")
	private String expireTime;



}
